      SUBROUTINE DE44D(F,M,K,INIAPR,IMAX,JSTART,YX,X,XJ0,AU,AJK,H,
     1                 HD4I,RABC,ALP,ALPN,CMAR,P,S,XP,YP,AJKP,U,ZFI)
      DOUBLE PRECISION YX,X,XJ0,AU,AJK,H,HD4I,RABC,ALP,ALPN,CMAR,P,S,
     1                 XP,YP,AJKP,U,ZFI,
     2                 KSI,WC1,WC2,WC3,HD2,HD4,HOLD
      DIMENSION YX(M),XJ0(K),AU(M,1),AJK(M,1),HD4I(1),RABC(K),ALP(K),
     1          ALPN(K),CMAR(K,K),P(1),S(1),YP(M),AJKP(M,1),U(M,K),
     2          ZFI(M,1)
      COMMON/COM70D/WC1,WC2,WC3,LASN,HD2,HD4,HOLD
      EXTERNAL F
      KP1=K+1
      KP2=K+2
      XP=X
      DO 45 L=1,M
   45 YP(L)=YX(L)
      IF (JSTART .NE. 0) GO TO 55
C  
C       THE FIRST STEP REALIZATION
C       CALCULATION OF ALL VARIABLES DEPENDING ON K
C  
      CALL DE70DK(K,RABC,ALP,ALPN,CMAR,P,S)
C  
C       CALCULATION OF ALL VARIABLES DEPENDING ON H
C       AND ALSO VARIABLES DEPENDING ON H AND K
C  
      CALL DE70DH(K,H,HD4I)
      DO 50 J=1,K
   50 XJ0(J)=XP+ALP(J)*H
      CALL DE70D0(F,M,K,XP,YP,XJ0,ALPN,CMAR,AJK,AU,U,ZFI)
      GO TO 110
C
C       THE NEXT STEP REALIZATION
C
   55 DO 60 J=1,K
   60 XJ0(J)=XP+ALP(J)*H
C       CHEBYSHEV COEFFICIENTS FROM PREVIOUS STEP ARE STORED
      DO 70 J=1,KP1
      DO 65 L=1,M
   65 AJKP(L,J)=AJK(L,J)
   70 CONTINUE
      IF (H .EQ. HOLD) GO TO 80
      KSI=H/HOLD
C       RECALCULATION OF ALL VARIABLS DEPENDING ON H
      CALL DE70DH(K,H,HD4I)
   80 IF (INIAPR .NE. 1) GO TO 85
C       CALCULATE INITIAL APPROXIMATION FROM INITIAL CONDITION ALWAYS
      CALL DE70D0(F,M,K,XP,YP,XJ0,ALPN,CMAR,AJK,AU,U,ZFI)
      GO TO 110
C       CALCULATE INITIAL APPROXIMATION BY EXTRAPOLATION OF COEFFICIENTS
C       AJK FROM PREVIOUS STEP
   85 IF (H .EQ. HOLD) GO TO 90
      CALL DE71DE(M,K,P,AJK,KSI,ZFI(1,KP2))
      GO TO 95
   90 CALL DE71DF(M,K,S,AJK,ZFI(1,KP2))
   95 CALL F(XP,YP,ZFI(1,1),M)
      DO 100 L=1,M
  100 ZFI(L,1)=ZFI(L,1)*WC2
  110 IEXIT=0
      DO 120 NU=1,IMAX
      CALL DE70DI(F,M,K,IEXIT,YP,XJ0,AJK,HD4I,RABC,ALPN,CMAR,AU,U,ZFI)
  120 CONTINUE 
      IEXIT=3
      CALL DE70DI(F,M,K,IEXIT,YP,XJ0,AJK,HD4I,RABC,ALPN,CMAR,AU,U,ZFI)
      CALL DE70DF(M,KP1,AU,YX)
      X=XP+H
      HOLD=H
      JSTART=1
  200 CONTINUE
      RETURN
      END                            
